#!/usr/bin/perl
# script to do raw zlib compression/decompression
# usage: 
# 	zpipe < uncompressed > compressed
# 	zpipe -d < compressed > uncompressed
# 	zpipe -h

use Compress::Raw::Zlib;

# check for -h
if($ARGV[0] eq '-h') {
  print "Usage:\n";
  print "  zpipe.pl -h\n";
  print "  zpipe.pl -d < compressed > uncompressed\n";
  print "  zpipe.pl < uncompressed > compressed\n\n";
  exit;
}

# check for -d (decompress option)
if($ARGV[0] eq '-d') {
  $inf = new Compress::Raw::Zlib::Inflate();
  binmode(STDIN);
  binmode(STDOUT);
  while(read(STDIN, $data, 1024)) {
    $inf->inflate(\$data, $out);
    print STDOUT $out;
  }
  exit;
}

# compress
$inf = new Compress::Raw::Zlib::Deflate(-WindowBits => 15);
binmode(STDIN);
binmode(STDOUT);
while(read(STDIN, $data, 1024)) {
  $inf->deflate(\$data, $out);
  print STDOUT $out;
}
$inf->flush($out);
print STDOUT $out;

1;

