#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "AS3.h"

// a C thunk for an AS3 function
AS3_Val someEntry(void *data, AS3_Val args)
{
  // set up some vars w/ default values
  int n = 34, k = 1234;
  double d = 12.34;
  char buf[256];

  // parse the input args (if there are <3 args, not all vars
  // will be set and will retain default values
  AS3_ArrayValue(args, "IntType, DoubleType, IntType", &n, &d, &k);

  // put something in the buf
  sprintf(buf, "%d %f %d", n, d, k);

  // return it
  return AS3_String(buf);
}

// a super simple async function
AS3_Val someEntry2(void *data, AS3_Val args)
{
  int val = 12;

  AS3_ArrayValue(args, "IntType", &val);

  // yield...
  flyield();

  // return a value
  return AS3_Int(val * 3);
}

int main()
{
  // regular function
  AS3_Val someEntryVal = AS3_Function(NULL, someEntry);

  // async function
  AS3_Val someEntry2Val = AS3_FunctionAsync(NULL, someEntry2);

  // construct an object that holds refereces to the 2 functions
  AS3_Val result = AS3_Object("someEntry: AS3ValType, someEntry2: AS3ValType",
    someEntryVal, someEntry2Val);

  AS3_Release(someEntryVal);
  AS3_Release(someEntry2Val);

  // notify that we initialized -- THIS DOES NOT RETURN!
  AS3_LibInit(result);

  // XXX never get here!
  return 0;
}
